Calendar Game(找规律+博弈)

A - Calendar Game

Time Limit:2000MS     Memory Limit:65536KB     64bit
IO Format:
%lld & %llu

Submit Status Practice ZOJ
1024

Appoint description: 
System Crawler  (2015-08-02)

Description

Adam and Eve enter this year‘s ACM International Collegiate Programming Contest. Last night, they played the Calendar Game, in celebration of this contest. This game consists of the dates from January 1, 1900 to November 4, 2001, the contest day. The game
starts by randomly choosing a date from this interval. Then, the players, Adam and Eve, make moves in their turn with Adam moving first: Adam, Eve, Adam, Eve, etc. There is only one rule for moves and it is simple: from a current date, a player in his/her
turn can move either to the next calendar date or the same day of the next month. When the next month does not have the same day, the player moves only to the next calendar date. For example, from December 19, 1924, you can move either to December 20, 1924,
the next calendar date, or January 19, 1925, the same day of the next month. From January 31 2001, however, you can move only to February 1, 2001, because February 31, 2001 is invalid.

A player wins the game when he/she exactly reaches the date of November 4, 2001. If a player moves to a date after November 4, 2001, he/she looses the game.

Write a program that decides whether, given an initial date, Adam, the first mover, has a winning strategy.

For this game, you need to identify leap years, where February has 29 days. In the Gregorian calendar, leap years occur in years exactly divisible by four. So, 1993, 1994, and 1995 are not leap years, while 1992 and 1996 are leap years. Additionally, the years
ending with 00 are leap years only if they are divisible by 400. So, 1700, 1800, 1900, 2100, and 2200 are not leap years, while 1600, 2000, and 2400 are leap years.

Input

The input consists of T test cases. The number of test cases (T) is given in the first line of the input. Each test case is written in a line and corresponds to an initial date. The three integers in a line, YYYY MM DD, represent the date of the DD-th day of
MM-th month in the year of YYYY. Remember that initial dates are randomly chosen from the interval between January 1, 1900 and November 4, 2001.

Output

Print exactly one line for each test case. The line should contain the answer "YES" or "NO" to the question of whether Adam has a winning strategy against Eve. Since we have T test cases, your program should output totally T lines of "YES" or "NO".

Sample Input 

3

2001 11 3

2001 11 2

2001 10 3

Output for the Sample Input

YES

NO

NO

题目大意是:

两个家伙在区域赛前夕闲的无聊,然后玩一种无限纠结的游戏,随即给定一个日期,每次只能移动day OR month..........

而且如果下一个月没有当前day的话, 你就不能移动month,比如1月31日,你只能移动day 使其到2月1日,而不能移动月让其到达2月31日,原因你懂的!

嗯,现在Adam开始YY了要!需要你来找一个必胜策略!(到达2001.11.4日就不能移动,无法移动的孩纸败,超过2001.11.4的也算输!)。

思路:没什么好的方法,找规律吧;

假设我站在先手的状态

(注意:  a -> b, 如果b全部是必胜态, 则a是必败态, 如果存在一个b是必败态,则a是必胜态。)

必败                  必胜

11.4                   11.3

11.2                   11.1

10.31                 10.30

10.29                 10.28

…………

10.5                   10.4

10.3                   10.2

10.1  
                9.30(聪明的人会选择转移到 10月1日)

9.28                  
9.29(聪明的人会选择跳到10.29)

…………

9.4                     9.3

9.2                     9.1

8.31                   8.30(聪明的人会选择转移到 8月31日)

8.29                   8.28

..........

8.5                     8.4

8.3                     8.2

8.1                     7.31

7.30                   7.29

..........

7.4                     7.3

7.2                     7.1

6.30(聪明的人会选择跳到7.30)

6.29                   6.28

..........

6.5                     6.4

6.3                     6.2

6.1                     5.31

5.30                   5.29

..........

5.4                     5.3

5.2                     5.1

4.30(聪明的人 会选择转移到5月30日)

4.29                   4.28

..........

4.5                     4.4

4.3                     4.2

4.1                     3.31

3.30                   3.29

3.28                   3.27

.........

3.4                     3.3

3.2                     3.1

2.29                   2.28

2.27                   2.26

..........

2.3                     2.2

2.1                     1.31

1.30                   1.29

1.28                   1.27

..........

1.4                     1.3

1.2                     1.1

12.31                 12.30

12.29                 12.28

..........

12.3                   12.2

12.1                   11.30(聪明的人会选择转移到12月1日)

11.29(聪明的人会选择转移到12.29)

11.28                 11.27

11.4                   11.3

.....................................................

不管是月份加一,还是日期加一,都改变了奇偶性,只有两个特殊日期9月30日,和11月30日例外。

那么目标日期是11月4日,为奇数。初始日期如果为偶数的话,先者必胜。

可以大致看到其实胜负和年份是没有关系的说,年份影响的只是2月是否存在第29天……而29是必败点,28为必胜……

看上图…得…必胜点 月份+日期 == 偶数 (除去两个例外)

特殊考虑……

转载请注明出处:寻找&星空の孩子

#include<stdio.h>
int main()
{
    int T;
    int yy,mm,dd;
    scanf("%d",&T);
    while(T--)
    {
        scanf("%d%d%d",&yy,&mm,&dd);
        if((mm+dd)%2==0)
            printf("YES\n");
        else if(dd==30&&(mm==11||mm==9))
            printf("YES\n");
        else printf("NO\n");
    }
    return 0;
}

版权声明:本文为博主原创文章,未经博主允许不得转载。

时间: 2024-08-02 15:13:44

Calendar Game(找规律+博弈)的相关文章

题解报告:hdu 1564 Play a game(找规律博弈)

题目链接:http://acm.hdu.edu.cn/showproblem.php?pid=1564 Problem Description New Year is Coming! ailyanlu is very happy today! and he is playing a chessboard game with 8600.The size of the chessboard is n*n. A stone is placed in a corner square. They play

2017EC Final L SOS——找规律&amp;&amp;博弈

题意 有n个格子排成一行,两人轮流填,可填入"S"或"0",先得到"SOS"的人胜:如果全部填完也没有出现"SOS",则为平局.请判断是先手胜.后手胜还有平局. 分析 第一次知道,博弈题也能打表找规律. 简单地说就是,给DFS一个返回值,返回三个不同的值分别代表先手胜.后手胜和平局. 枚举当前填的格子,如果出现后手出现必败态,先手胜,直接返回:如果后手出现平局,则存在平局:否则,后手败. (好像超内存了...问题不大 不难得出

HDU 1079 Calendar Game(规律博弈)

题目链接:https://cn.vjudge.net/problem/HDU-1079 题目: Adam and Eve enter this year's ACM International Collegiate Programming Contest. Last night, they played the Calendar Game, in celebration of this contest. This game consists of the dates from January 1

HDU 2147 找规律博弈

题目大意: 从右上角出发一直到左下角,每次左移,下移或者左下移,到达左下角的人获胜 到达左下角为必胜态,那么到达它的所有点都为必败态,每个点的局势都跟左,下,左下三个点有关 开始写了一个把所有情况都计算的打表 for(int i=n ; i>=1 ; i--){            for(int j=1 ; j<=m ; j++){                bool flag1 = p[i][j-1];                bool flag2 = p[i+1][j];  

HDU 1564 找规律博弈

题目大意是: 从n*n的方格角落的一个起点出发,每次移到上下左右一个未曾到达过的位置,谁不能走了谁就输了 想了好久都想不出,看了大神的题解 Orz了 果然博弈不是脑残的游戏啊... 这里从起点出发,将所有方格两两连接,如果为偶数,那么这个起点会有一个对应方格与其两两连接,那么起点说明已经占据了一格 那么每次先手只要走到当前格对应相连的格子上就保证可以有路,那么后手就输了 反之n为基数,那么没有点与起点相连,说明先手必然走入一个新的1*2的小长条中,那么后手始终有1*2的小长条的方格与其对应,所以

HDU 5963 朋友(找规律博弈)

http://acm.hdu.edu.cn/showproblem.php?pid=5963 题意: 思路: 我们可以先只考虑单链,自己试几种案例就可以发现规律,只有与根相连的边为1时,只需要奇数次操作,也就是1次就可以,而别的都需要偶数次操作才能把这条链上的边权全变成0,次数为$2^{n-1}$,n为边的层数.所以我们只要统计与根相连的有多少条权值为1的边即可. 需要改权值的时候搜索一下找到边然后修改. 1 #include<iostream> 2 #include<algorithm

POJ 2505 A multiplication game(找规律博弈/贪心)

题目链接 #include<iostream> #include<cstdio> using namespace std; typedef long long ll; int main() { ll n; while(~scanf("%I64d",&n)) {//其实算是 贪心了吧 //先手想赢,他会x2,这样子才能尽量避免让后手赢 //后手想赢,他就会x9,只有乘最大的,他胜算才最大 int t=0; ll l=1,r=9; while(1) { if

hdu 1525 找规律博弈 (根据每一步的必然性以及可选择性决策)

题目来源:http://acm.hdu.edu.cn/showproblem.php?pid=1525 题意: 给出两个数,a和b,将大的数中,减去若干b的倍数,最终有一个数为0的话就胜了. 分析:  两个数a和b, 不妨设(a > b),总会出现的一个局面是b,a%b,这是必然的,如果a>=b&&a<2*b,那么只有一种情况,直接到b,a%b.否则有多种情况. a / b == 1   即a Ε [b , 2b)  , 下一步 只能到达   (b , a  - b) a

POJ 1740 A New Stone Game 又是博弈论配对找规律orz 博弈论 规律

http://poj.org/problem?id=1740 这个博弈一眼看上去很厉害很高大上让人情不自禁觉得自己不会写,结果又是找规律-- 博弈一般后手胜都比较麻烦,但是主要就是找和先手的对应关系,依然看了题解-- 如果所有石头堆两两配对的话后手对先手的每一步都可以对应走一步,那么此时后手必胜. 如果不是两两配对,先手可以通过一次操作使石头堆两两配对,此时的两两配对局面面对的是后手,所以先手必胜. 不是两两配对时的操作:首先将所有非配对推按大小排序(只有一堆直接取没就可以了): 然后显然不配对